/*
** File     : UScrollValues.cpp
** Author   : Marjan Slatinek
** Date     : 03/07/99
** Version  : BCB4
**
** Comments: I acquire data from a sensor. I would like to display
             only last ten seconds of data. How can I achive this?
/---------------------------------------------------------------------------
*/


//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "UScrollValues.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ABarSeriesExecute(TObject *Sender)
{
        ChangeSeriesType(Chart1->SeriesList->Series[0], __classid(TBarSeries));
        dynamic_cast<TBarSeries *>(Chart1->SeriesList->Series[0])->BarPen->Visible=false;
        dynamic_cast<TBarSeries *>(Chart1->SeriesList->Series[0])->SideMargins=false;
        ABarSeries->Checked=true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ALineSeriesExecute(TObject *Sender)
{
        ChangeSeriesType(Chart1->SeriesList->Series[0], __classid(TLineSeries));
        ALineSeries->Checked=true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::APointSeriesExecute(TObject *Sender)
{
        ChangeSeriesType(Chart1->SeriesList->Series[0], __classid(TPointSeries));
        dynamic_cast<TPointSeries *>(Chart1->SeriesList->Series[0])->Pointer->VertSize=2;
        dynamic_cast<TPointSeries *>(Chart1->SeriesList->Series[0])->Pointer->HorizSize=2;
        dynamic_cast<TPointSeries *>(Chart1->SeriesList->Series[0])->Pointer->Style=psCross;
        APointSeries->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ATenSecExecute(TObject *Sender)
{
        ATenSec->Checked=true;
        limit=DateTimeStep[dtTenSeconds];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AThirthySecExecute(TObject *Sender)
{
        AThirthySec->Checked=true;
        limit=DateTimeStep[dtThirtySeconds];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AOneMinExecute(TObject *Sender)
{
        AOneMin->Checked=true;
        limit=DateTimeStep[dtOneMinute];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        TTime tmpT=Time();
        Chart1->Series[0]->AddXY(tmpT,random(5)*sin(500000*tmpT),"",clTeeColor);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        Chart1->Series[0]->Clear();
        Chart1->Series[0]->XValues->DateTime=true;
        Chart1->Series[0]->GetVertAxis->Automatic=false;
        Chart1->Series[0]->GetVertAxis->SetMinMax(-5,5);
        Chart1->Series[0]->GetVertAxis->Increment=0.5;
        Chart1->Series[0]->GetHorizAxis->DateTimeFormat="hh:mm:ss";
        Chart1->Series[0]->GetHorizAxis->AxisValuesFormat="#0.000000";
        ATenSecExecute(this);
        ALineSeriesExecute(this);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Series1ClearValues(TChartSeries *Sender)
{
        full=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Series1AfterAdd(TChartSeries *Sender,
      int ValueIndex)
{
        Sender->GetHorizAxis->Automatic=false;
        if (full)
        {
         Sender->GetHorizAxis->Maximum=Sender->XValues->MaxValue;
         Sender->GetHorizAxis->Minimum=Sender->GetHorizAxis->Maximum-limit;
        }
        else
        {
         Sender->GetHorizAxis->Minimum=0;
         Sender->GetHorizAxis->Maximum=Sender->XValues->MinValue+limit;
         Sender->GetHorizAxis->Minimum=Sender->XValues->MinValue;
        }

         full=Sender->XValues->MaxValue>Sender->GetHorizAxis->Maximum;





        while ((Sender->Count()>0) && (Sender->XValues->Value[0] < Sender->GetHorizAxis->Minimum))
        {
         Sender->Delete(0);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AFastLineSeriesExecute(TObject *Sender)
{
        ChangeSeriesType(Chart1->SeriesList->Series[0], __classid(TFastLineSeries));
        AFastLineSeries->Checked=true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
        Chart1->Series[0]->GetHorizAxis->Labels=CheckBox1->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
        Chart1->Series[0]->GetHorizAxis->Grid->Visible=CheckBox2->Checked;        
}
//---------------------------------------------------------------------------

